/*****************************/
/* Code 5.14 (Example 5.5.1) */
/*****************************/
module multiplier_8b (opa, opb, result);
  parameter SIZE = 8, LongSize = 2*SIZE;
  input  [SIZE-1:0]     opa, opb;
  output [LongSize-1:0] result;
  reg    [LongSize-1:0] result;
  reg    [LongSize-1:0] shift_opa, shift_opb;

  always @(opa or opb) begin
      shift_opa = opa;
      shift_opb = opb;
      result = 0;
      repeat (SIZE) begin
  	     if (shift_opb[0])
		        result = result + shift_opa;
	       shift_opa = shift_opa << 1;
	       shift_opb = shift_opb >> 1;
      end
  end
endmodule